//File: Statistics.java
// A program that calculates statistics on an integer array
// Assignment: Unit 2 - Assignment 3

import java.util.Scanner;
/********************************************************
 * Calculate various statistics on an array of integers.
 * @author Barbara Fox (bfox@ncchristian.org)
 * @version 2008.07.25
 ********************************************************/

public class Statistics{
  
    private int list[] = new int[10];;
    
    /**
     * Constructor stores a list of integers in private list
     * @param a  an integer array holding initial values
     * <dd><b>Postcondition</b></dd><dt>array list[] populated with 10 values</dt>
    **/
    public Statistics (int[] a) {
        list=a;
    }
    
    /**
     * Default constructor prompts user for integer values
    **/
    public Statistics () {
     Scanner reader = new Scanner(System.in);
      int list[] = new int[10];
      // Get the inputs
      for (int i = 0; i < 10; i++){
         System.out.print("Enter an integer: ");
         list[i] = reader.nextInt();
      }
    }

    /** 
    * Calculate the average of an array of integers
    * @param a integer array
    * @return the average (i.e. mean)
    * <dt><b>Precondition:</b></dt><dd> a[] contains 10 integers</dd>
    **/
    public double average(int a[]) {

     int sum=0;
     for (int element : a) {
       sum = sum + element; 
     }
     return (sum/a.length);
    }

    /**
    * Determine which number occurs most often
    * @param a integer array
    * @return the number which occurs most often
    * <dt><b>Precondition:</b></dt>
    *   <dd> a[] contains 10 integers</dd>
    * <dt><b>Postcondition:</b></dt>
    *   <dd>If more than 1 number meets criteria, return 1st one</dd>
    **/
    // requirements state use parallel arrays. First will be
    //   called values and contains unique list of values in a.
    //   Second is called frequencies and is how many times each value occurs
    public int mode(int a[]){
        int values[] = new int[a.length];
        int frequencies[] = new int[a.length];
        int uniqueValueCount = 0;
        for (int i : a)
            uniqueValueCount = insertValueAndFreq(i, values, frequencies, uniqueValueCount);
        int positionOfMode = maxPosition(frequencies, uniqueValueCount);
        return values[positionOfMode];
    }

    /**
     * Keep track of how many occurrences there are of each letter
     * @param value the value being counted for number of occurrences
     * @param values[] array of already discovered values
     * @param frequencies[] parallel array containing number of times each value occurs
     * @param uVC counter holding number of unique values so far
     * @return uVC how many unique values discovered so far
     **/
    public int insertValueAndFreq(int value, int values[], int frequencies[], int uVC){
       // If value is not in values array, inserts it and sets its frequency to 1.
       // Otherwise, increments frequency of existing value in values array.
        int probe = 0;
        boolean found = false;
        while (probe < uVC && ! found)
            if (values[probe] == value){
                frequencies[probe]++;
                found = true;
            }
            else
                probe++;
        if (! found){
            values[probe] = value;
            frequencies[probe] = 1;
            return uVC + 1;
        }
        else
            return uVC;
   }

    /** 
     * Find index position of largest number in array
     * @param a array of integers
     * @param count how many values in the array
     * @return index position of largest number in array. Report first number if there is a tie.
     **/
   public int maxPosition(int a[], int count){
      int maxPosition = 0;
      for (int i = 1; i < count; i++)
         if (a[maxPosition] < a[i])
            maxPosition = i;
      return maxPosition;
   }

   
    /** 
     * Display numbers of array
     * @param a array of integers
     * @return nothing
     **/
   public  void displayList(int a[]){
      for (int i : a)
         System.out.print(i + " ");
   }
}
