import junit.framework.TestCase;

/**
 * A JUnit test case class.
 * Every method starting with the word "test" will be called when running
 * the test with JUnit.
 */
public class TestBankAccount extends TestCase {
  
  /**
   * A test method.
   * (Replace "X" with a name describing the test.  You may write as
   * many "testSomething" methods in this class as you wish, and each
   * one will be called when running JUnit over this class.)
   */
  public void testDeposit100() {
    BankAccount b =  new BankAccount("Abel",500);
    b.deposit(100.00);
    assertEquals("$100 deposit failed", (int) 600, (int) b.getBalance());   
  }
  
    public void testDeposit0() {
    BankAccount b =  new BankAccount("Abel",500);
    b.deposit(0);
    assertEquals("$0 deposit failed", (int) 500, (int) b.getBalance());   
  }
    
  public void testWithdrawToNegative() {
    BankAccount b =  new BankAccount("Abel",500);
    assertTrue("Overdrawn did not return an error but should have", b.withdraw(600) != null);   
  }
  
  public void testCheckBalanceWhenOverdraw() {
    BankAccount b =  new BankAccount("Abel",500);
    b.withdraw(600);
    assertEquals("Balance should not have changed", 50000, (int) (b.getBalance() * 100)); 
  }
  
  public void testGetName() {
    BankAccount b =  new BankAccount("Abel",500);
    assertEquals("Wrong customer name","Abel",b.getName());
  }
}
