import junit.framework.TestCase;

public class TestSalary extends TestCase {

  //What if salary is set to zero?
  public void test_NoSalary() {
    Salary s = new Salary(0,5,5);
    assertEquals("Starting Salary of Zero produced wrong result",0, s.calculateSalary());
  }
  
  
  //What if percentage per year increase is set to zero?
  public void test_NoIncrease() {
    int startSal=10000;
    Salary s = new Salary(startSal,0,5);
    assertEquals("If increase is set to zero, program fails",startSal, s.calculateSalary());
  }
  
    //What if number of years is set to zero?
  public void test_NoYears() {
    int startSal=30000;
    Salary s = new Salary(startSal,0,5);
    assertEquals("If increase is set to zero, program fails",startSal, s.calculateSalary());
  }
  
    //What if no parameters are given?
   public void test_NoValues() {
    Salary s = new Salary();
    assertEquals("If no values are given, program fails",0, s.calculateSalary());
  }
   
    //What if teacher works 1 year at 10%?
   public void test_NewTeacher() {
    int startSal=30000;
    Salary s = new Salary(startSal,10,0);     
    assertEquals("Failed if teacher just hired",30000, s.calculateSalary());
  }
       //What if teacher works 1 year at 10%?
   public void test_1YearTeacher() {
    int startSal=30000;
    Salary s = new Salary(startSal,10,1);     
    assertEquals("Failed if teacher just hired",30000, s.calculateSalary());
  }
   
       //What if teacher works 2 years at 10%?
   public void test_2YearTeacher() {
    int startSal=30000;
    Salary s = new Salary(startSal,10,2);     
    assertEquals("Failed if teacher works 2 years @ 10%",33000, s.calculateSalary());
  }
}
